BEGIN{
 while(getline < list){ installed[$2] = $1; dep[$2] = $3}
 while(getline < moved){
  if(/^#/) continue
  if($2 ~ /^$/){
   printf("# obsolete port %s\n", $1)
   if($1 in installed){delete insalled[$1]; delete dep[$1]}
  }
  else{
   printf("# %s moved to %s\n", $1, $2)
   if($1 in installed){
    printf("# delete installed[%s] = %s\n", $1, installed[$1])
    installed[$2] = installed[$1]; delete installed[$1];
    dep[$2] = dep[$1]; delete dep[$1];
   }
  }
 } # while
} # BEGIN
{ if($2 in filter) next; else filter[$2] = $2 } # remove duplicate
 $2 in installed{ pkg = installed[$2];
  if(!ignore($1) && !ignore($2) && need_upgrade(pkg, $1))
  {oldpkg = "$(PKG_DIR)" pkg; newpkg = "$(PKG_DIR)" $1
   printf("# upgrade %s to %s\n", pkg, $1);
   actionp($1, $2, "UPGRADE")
   printf(".PHONY : %s\n", oldpkg)
   printf("%s : %s\n", oldpkg, newpkg)
   printf("ECHO_%s = echo %s to %s &&\n", newpkg, pkg, $1);
   printf("OLD_PKG_%s = %s$(PKG_SUFFIX)\n", newpkg, pkg);
   printf("BACKUP_PKG_%s = [ -f $(PORTS+_BKUP)$(OLD_PKG_%s) ] || (cd $(PORTS+_BKUP) && pkg_create -b $(OLD_PKG_%s))\n", newpkg, newpkg, newpkg);
   printf("INSTALL_%s = ($(BSDMAKE) deinstall reinstall && find $(PKG_DIR) -name \"+CONTENTS\" | xargs grep -l %s | xargs $(REPLACE) \"/pkgdep/s^%s^%s^g\")\n", newpkg, pkg, pkg, $1);
   printf("RESTORE_PKG_%s = pkg_add -f $(PORTS+_BKUP)$(OLD_PKG_%s)\n", newpkg, newpkg);
   printf("OLD_%s = $(PKG_DIR)%s\n", newpkg, pkg); # Do I need this line?
  }
  else
   actionp($1, $2, "NOOP")
 dependp($1, dep[$2]) # dependencies taken from /var/db/pkg/*/+CONTENTS
}
function need_upgrade(one, another){
 i = split(one, tmp, "-"); n = split(tmp[i], o, "[._,]");
 i = split(another, tmp, "-"); m = split(tmp[i], a, "[._,]");
 max = n > m ? n : m;
 for(i = 1; i <= max; i++) if(o[i] < a[i]) return 1; return 0;
 if(one >= another) return 0;
 return 1;
}
